various updates
[distro-setup] / .bashrc
diff --git a/.bashrc b/.bashrc
index ae0da0ae4d11bce5a50a3cde6c35899179571c02..f92ecc0e63cf1f347c22bd73331f54860b418ad5 100644 (file)
--- a/.bashrc
+++ b/.bashrc
@@ -1,3 +1,4 @@
+PATH="$PATH:/opt/midfin/common/lib"
 # to debug
 #set -x
 # redirect output to log file
@@ -5,34 +6,36 @@
 #exec 2>/a/tmp/bashlog
 
 
-# By default this file is sourced for all ssh commands. This is wonky.
-# Normally, this file is not sourced when a script is run, and it would be much
-# better and more consistent if that also happened when when running a script
-# over ssh. so here we test for conditions of a script under ssh and return if
-# so.  we can override with ssh -t which sets $SSH_TTY, which we can detect
+# By default this file is sourced for ALL ssh commands. This is wonky.
+# Normally, this file is not sourced when a script is run, but we can override
+# that by having #!/bin/bash -l.
+# I want something similar for ssh commands. when a local script runs an ssh command,
+# this file should not be sourced by default, but we should be able to override that.
+#
+# so here we test for conditions of a script under ssh and return if so. To test
+# for an overriding condition, we have a few options. one is to use an
+# environment variable.  env variables sent across ssh are strictly limited. ssh
+# -t which sets $SSH_TTY, but within a script that won't work because tty
+# allocation will fail.  We could override an obscure unused LC_var, like
+# telephone, but I don't want to run into some edge case where that messes
+# things up. we could transfer a file which we could test for, but I can't think
+# of a way to make that inherently limited to a single ssh command.  I choose to
+# set SendEnv and AcceptEnv ssh config vars to allow the environment variable
+# BASH_LOGIN_SHELL to propagate across ssh.
+
+# assume we want ssh commands to source this file if we are sourcing it,
+# and we haven't specified otherwise already
+[[ ! $BASH_LOGIN_SHELL ]] && export BASH_LOGIN_SHELL=true
+
+# first conditions show that we are an ssh command without an interactive shell
 if [[ $SSH_CONNECTION ]] \
-   && [[ $- == *c* ]] \
-   && [[ ! $SSH_TTY ]] \
-   && [[ $- != *i* ]]; then
+       && [[ $- == *c* ]] \
+       && [[ ! $SSH_TTY ]] \
+       && [[ $- != *i* ]] \
+       && [[ ! $BASH_LOGIN_SHELL == true ]]; then
     return
 fi
 
-# Side note on ssh. Command lines and env variables sent across ssh are strictly limited.
-# If we did want to easily pass info, we could override an obscure unused LC_var
-# Or we could set SendEnv and AcceptEnv ssh vars, or we could transfer a file.
-
-
-
-###################
-## include files ###
-###################
-
-for x in $HOME/bin/bash-programs-by-ian/repos/*/*-function; do
-    source "$x"
-done
-
-source $HOME/bin/semi-private # so I can share my bashrc
-source $HOME/path_add-function
 
 
 
@@ -41,37 +44,41 @@ source $HOME/path_add-function
 # settings #
 ############
 
-CDPATH=.:/a
+CDPATH=.
+
+# remove all aliases. aliases provided by the system tend to get in the way,
+# for example, error happens if I try to define a function the same name as an alias
+unalias -a
 
 # remove gnome keyring warning messages
 # there is probably a more proper way, but I didn't find any easily on google
-unset GNOME_KEYRING_CONTROL
-
-path_add /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
+# now using xfce+xmonad instead of vanilla xmonad, so disabling this
+#unset GNOME_KEYRING_CONTROL
 
-#use extra globing features. See man bash, search extglob.
+# use extra globing features.
 shopt -s extglob
-#include .files when globbing.
-shopt -s dotglob
+# include .files when globbing, but ignore files name . and ..
+# setting this also sets dotglob
+export GLOBIGNORE=*/.:*/..
 
-# disabled because it is broken with bash_completion package. It is a known bug they hope to fix.
-# When a glob expands to nothing, make it an empty string instead of the literal characters.
-# shopt -s nullglob
+# broken with bash_completion package. Saw a bug for this once. Don't anymore.
+# still broken in wheezy
+# still buggered in latest stable from the web, version 2.1
+# perhaps its fixed in newer git version, which fails to make for me
+# this note is from 6-2014
+#shopt -s nullglob
 
 # make tab on an empty line do nothing
 shopt -s no_empty_cmd_completion
 
-
 # advanced completion
 # http://bash-completion.alioth.debian.org/
-# i was using the git version for a while for a bug fix.
-# it's made it into distros now
-# usually this is sourced by the system already,
-# but I check just incase
+# might be sourced by the system already, but I've noticed it not being sourced before
 if ! type _init_completion &> /dev/null && [[ -r "/usr/share/bash-completion/bash_completion" ]]; then
     . /usr/share/bash-completion/bash_completion
 fi
 
+
 # fix spelling errors for cd, only in interactive shell
 shopt -s cdspell
 # append history instead of overwritting it
@@ -80,24 +87,28 @@ shopt -s histappend
 shopt -s checkwinsize
 # attempt to save multiline single commands as single history entries.
 shopt -s cmdhist
+shopt -s globstar
+
 
 # inside emacs fixes
 if [[ $INSIDE_EMACS ]]; then
+    # EMACS is used by bash on startup, but we don't need it anymore.
+    # plus I hit a bug in a makefile which inherited it
+    unset EMACS
     export INSIDE_EMACS
     export PAGER=cat
     export MANPAGER=cat
-    # for readline-complete.el
-    stty echo
-else
-    # terminal keys: C-c, C-z. the rest defined by stty -a are, at least in
-    # gnome-terminal, overridden by bash, or disabled by the system
-    stty werase undef lnext undef stop undef start undef
+    # scp completion does not work, but this doesn't fix it. todo, figure this out
+    complete -r scp &> /dev/null
+    # todo, remote file completion fails, figure out how to turn it off
 fi
 
 
 if [[ $- == *i* ]]; then
     # for readline-complete.el
     if [[ $INSIDE_EMACS ]]; then
+        # all for readline-complete.el
+        stty echo
         bind 'set horizontal-scroll-mode on'
         bind 'set print-completions-horizontally on'
         bind '"\C-i": self-insert'
@@ -110,6 +121,10 @@ if [[ $- == *i* ]]; then
             bind '"\eOc": shell-forward-word'
             bind '"\eOd": shell-backward-word'
         fi
+        # terminal keys: C-c, C-z. the rest defined by stty -a are, at least in
+        # gnome-terminal, overridden by bash, or disabled by the system
+        stty werase undef lnext undef stop undef start undef
+
     fi
 
 fi
@@ -132,15 +147,14 @@ HISTFILE=$HOME/.bh
 HISTTIMEFORMAT="%I:%M %p %m/%d "
 # consecutive duplicate lines don't go in history
 HISTCONTROL=ignoredups
-# just defensively unsetting this
-# this var can replace HISTCONTROL to do more flexible things like
-# not saving single char history items or specific names
-unset HISTIGNORE
+# works in addition to HISTCONTROL to do more flexible things
+# it could also do the same things as HISTCONTROL and thus replace it,
+# but meh
+HISTIGNORE="k *"
 
 export BC_LINE_LENGTH=0
 
-path_add /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
-path_add $HOME/bin/bash-programs-by-ian/utils
+
 # note, if I use a machine I don't want files readable by all users, set
 # umask 077  # If fewer than 4 digits are entered, leading zeros are assumed
 
@@ -149,14 +163,32 @@ C_DEFAULT_DIR=/a
 
 
 
+###################
+## include files ###
+###################
+
+for _x in $HOME/bin/bash-programs-by-ian/repos/*/*-function ~/bin/distro-functions/src/*; do
+    source "$_x"
+done
+unset _x
+source $HOME/bin/semi-private # so I can share my bashrc
+source $HOME/path_add-function
+path_add --ifexists --end /a/opt/adt-bundle*/tools /a/opt/adt-bundle*/platform-tools
+path_add --ifexists --end /a/bin/sda/corpnext/cloudinit
+# todo, these need to be renamed to be less generic.
+# sync overrode something else useful
+#path_add $HOME/bin/bash-programs-by-ian/utils
+source $HOME/mw_vars
+
 ###############
 ### aliases ###
 ###############
 
-if [[ $- == *i* ]]; then
-    alias cp='cp -i'
-    alias mv='mv -i'
-fi
+# disabled for now, but these are generally good
+# if [[ $- == *i* ]]; then
+#     alias cp='cp -i'
+#     alias mv='mv -i'
+# fi
 
 # remove any default aliases for these
 alias ls > /dev/null 2>&1 && unalias ls
@@ -172,25 +204,27 @@ mkdir() {
 alias d='builtin bg'
 complete -A stopped -P '"%' -S '"' d
 
-alias his='history'
+alias hi='history'
 
 
 # note: gksudo is recommended for X apps because it does not set the
-# home directory to the same.
-
-if [[ $- == *i* ]]; then
-    # extra space at the end allows aliases to work
-    alias s='SUDOD="$PWD" sudo -i '
-else
-    s() {
-        if [[ $EUID != 0 || $1 == -* ]]; then
-            local SUDOD="$PWD"
-            sudo -i "$@"
-        else
-            "$@"
-        fi
-    }
-fi
+# home directory to the same, and thus apps writing to ~ fuck things up
+# with root owned files.
+
+# background
+# alias s='SUDOD="$PWD" sudo -i '
+# because this is an alias, and the extra space at the end, it would allow
+#  aliases to be used with it. but aliases aren't used in scripts,
+#  better to eliminate inconsistencies. Plus, you can't do s=s; $s command
+#  with an alias, which I like to do in some functions
+# extra space at the end allows aliases to work
+s() {
+    if [[ $EUID != 0 || $1 == -* ]]; then
+        SUDOD="$PWD" sudo -i "$@"
+    else
+        "$@"
+    fi
+}
 
 
 
@@ -205,12 +239,50 @@ if [[ $OS == Windows_NT ]]; then
 fi
 
 
+
+
+
 #####################
 ###  functions   ####
 #####################
 
 
 
+# netselect-apt finds a fast mirror.
+# but we need to replace the mirrors ourselves,
+# because it doesn't do that. best it can do is
+# output a basic sources file
+# here we get the server it found, get the main server we use
+# then substitute all instances of one for the other in the sources file
+# and backup original to /etc/apt/sources.list-original.
+# this is idempotent
+debian_pick_mirror () {
+    local x=$(mktemp -d)/f # safe way to get file name without creating one
+    sudo netselect-apt -o "$x" || return 1
+    x=$(_debian_pick_mirror_grep stable "$x")
+    sudo cp -f /etc/apt/sources.list /etc/apt/sources.list-original
+    sudo sed -i "s/$(_debian_pick_mirror_grep wheezy)/$x/" /etc/apt/sources.list
+    aptitude update
+}
+
+_debian_pick_mirror_grep () {
+    local x="$(grep -oP "^deb [^ ]+ $1 " ${2-/etc/apt/sources.list})"
+    x="${x#deb }"
+    x="${x% $1 }"
+    # replace / with \/ so we can use it with sed
+    echo "${x//\//\\/}"
+}
+
+# portable daemon, for debian & fedora
+pdaemon () {
+    if isdeb; then
+        sudo /etc/init.d/$1 $2
+    else
+        sudo systemctl $2 $1.service
+    fi
+}
+
+
 a() {
     beet "${@}"
 }
@@ -225,20 +297,89 @@ if type ack-grep >/dev/null 2>&1; then
     alias ack=ack-grep
 fi
 
+postconfin() {
+    local MAPFILE
+    mapfile -t
+    local s
+    [[ $EUID == 0 ]] || s=s
+    $s postconf -v "${MAPFILE[@]}"
+}
 
 gr() {
-    grep -i --binary-files=without-match --color=auto "$@"
+    grep -iI --color=auto "$@"
 }
 
 grr() {
-    grep -ri --binary-files=without-match --color=auto "$@"
+    grep -riI --color=auto "$@"
+}
+
+pub() {
+    rld /a/h/_site/ li:/var/www/iankelling.org/public_html
 }
 
+bashrcpush () {
+    local startdir="$PWD"
+    cd ~
+    for x in "$@"; do
+        ssh $x mkdir -p bin/distro-functions/src
+        tar cz bin/bash-programs-by-ian bin/semi-private bin/distro-functions/src | ssh $x tar xz
+    done
+    cd $(mktemp -d)
+    command cp /a/c/repos/bash/!(.git) ~/.gitconfig .
+    for x in "$@"; do
+        tar cz * | ssh $x tar xz
+    done
+    cd "$startdir"
+}
 
+whatismyip() { curl ipecho.net/plain ; echo; }
 
+# history search
+k() { grep -P "$@" ${HISTFILE:-~/.bash_history}  | tail -n 40; }
 
 calc() { echo "scale=3; $*" | bc -l; }
 
+# diff config files,
+# setup for format of postfix
+# option = stuff[,]
+#    [more stuff]
+cdiff() {
+
+    local pastline
+    local unified="$(mktemp)"
+    local f1="$(mktemp)"
+    local f2="$(mktemp)"
+
+    _cdiff-prep "$1" "$f1"
+    _cdiff-prep "$2" "$f2"
+    cat "$f1" "$f2" |  grep -Po '^[^=]+=' | sort | uniq > "$unified"
+    while IFS= read -r line; do
+        # the default bright red / blue doesn't work in emacs shell
+        dwdiff -cblue,red -A best -d "         ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
+    done < "$unified"
+}
+
+
+# join options which are continued to multiples lines onto one line
+_cdiff-prep() {
+    local first=true
+    grep -vE '^([ \t]*#|^[ \t]*$)' "$1" | while IFS= read -r line; do
+                                              # remove leading spaces/tabs. assumes extglob
+                                              if [[ $line == "[        ]*" ]]; then
+                                                  line="${line##+( )}"
+                                              fi
+                                              if $first; then
+                                                  pastline="$line"
+                                                  first=false
+                                              elif [[ $line == *=* ]]; then
+                                                  echo "$pastline" >> "$2"
+                                                  pastline="$line"
+                                              else
+                                                  pastline="$pastline $line"
+                                              fi
+                                          done
+    echo "$pastline" >> "$2"
+}
 
 # makes it so chown -R symlink affects the symlink and its target.
 chown() {
@@ -269,15 +410,6 @@ dc() {
 }
 
 
-distro_name() {
-    if [[ -f /etc/fedora-release ]]; then
-        echo fedora
-    else
-        grep "^ID=.*" /etc/os-release | sed 's/^ID=//'
-    fi
-}
-
-
 dt() {
     date "+%A, %B %d, %r" "$@"
 }
@@ -332,12 +464,21 @@ git_empty_branch() { # start an empty git branch. carefull, it deletes untracked
     [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
     local gitroot
     gitroot || return 1 # function to set gitroot
-    builtin cd $gitroot
+    builtin cd "$gitroot"
     git symbolic-ref HEAD refs/heads/$1
     rm .git/index
     git clean -fdx
 }
 
+
+ff() {
+    if type -P firefox &>/dev/null; then
+        firefox "$@"
+    else
+        iceweasel "$@"
+    fi
+}
+
 fw() {
     firefox -P default "$@" >/dev/null 2>&1
 }
@@ -362,6 +503,10 @@ i() {
 complete -o bashdefault -o default -o nospace -F _git i 2>/dev/null \
     || complete -o default -o nospace -F _git i
 
+# fast commit all
+ic() {
+    git commit -am "$*"
+}
 
 # insensitive find
 ifn () {
@@ -370,6 +515,7 @@ ifn () {
 
 
 
+
 l() {
     if [[ $PWD == /[iap] ]]; then
        command ls -A --color=auto -I lost+found "$@"
@@ -379,6 +525,7 @@ l() {
 }
 
 
+
 lld() { ll -d "$@"; }
 
 
@@ -422,89 +569,9 @@ despace() {
     done
 }
 
-# force symbolic link creation.
-# trash-put any existing files where links would be created.
-# mkdir -p the directory containing the link(s) if needed.
-# then do ln -s -- "$@"
-lnf() {
-    if [[ $# -gt 2 && ! -d ${!#} ]]; then
-        mkdir -p "${!#}"
-    fi
-    if [[ $# -gt 1 && -d ${!#} ]]; then
-        local oldcwd=$PWD
-        cd ${!#} # last arg
-        for x in "${@:1:$(($#-1))}"; do # all but last arg
-            # remove any trailing slashes
-            x="${x%%+(/)}"
-            # remove any leading directory components
-            x="${x##*/}"
-            te "$x" && trash-put "$x"
-        done
-        cd "$oldcwd"
-    elif [[ $# -eq 2 ]]; then
-        if te "$2"; then
-            trash-put "$2"
-        elif [[ ! -d $(getdir "$2") ]]; then
-            mkdir -p $(getdir "$2")
-        fi
-    else
-        te "${1##*/}" && rm "${1##*/}"
-    fi
-    ln -s -- "$@"
-}
 
 
 
-# package manager
-# aliases would be much more compact, but they can't be used as ssh commands
-# also, to be used in a script, you need -i which prints annoying
-# warnings. instead, use -l in a script to source this file
-if type -p yum > /dev/null; then
-    p() {
-        if [[ $EUID == 0 ]]; then
-            yum "$@"
-        else
-            sudo yum "$@"
-        fi
-    }
-    pi() {
-        if [[ $EUID == 0 ]]; then
-            yum -y install "$@"
-        else
-            sudo yum -y install "$@"
-        fi
-    }
-    pf() {
-        if [[ $EUID == 0 ]]; then
-            yum search "$@"
-        else
-            sudo yum search "$@"
-        fi
-    }
-else
-    p() {
-        if [[ $EUID == 0 ]]; then
-            aptitude "$@"
-        else
-            sudo aptitude "$@"
-        fi
-    }
-    pi() {
-        if [[ $EUID == 0 ]]; then
-            aptitude -y install "$@"
-        else
-            sudo aptitude -y install "$@"
-        fi
-    }
-    pf() {
-        if [[ $EUID == 0 ]]; then
-            aptitude search "$@"
-        else
-            sudo aptitude search "$@"
-        fi
-    }
-fi
-
 
 # test existence / exists
 te() {
@@ -515,6 +582,11 @@ te() {
     return $ret
 }
 
+# show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
+make-targets() {
+    make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
+}
+
 
 # fix root file ownership for FILE argument.
 # check if parent or grandparent is not root and if the dir of FILE is also
@@ -522,7 +594,7 @@ te() {
 perm_fix() {
     local parent
     if [[ $EUID == 0 ]]; then
-       te "$1" || touch $1
+       te "$1" || touch "$1"
        if [[ $(stat -c "%u" "$1") == 0 ]] ; then
            argdir=$(getdir "$1")
            if [[ $(stat -c "%u" "$argdir") != 0 ]] ; then
@@ -535,6 +607,94 @@ perm_fix() {
     fi
 }
 
+# see notes for usage
+fsdiff () {
+    local missing=false
+    local dname="${PWD##*/}"
+    local m="/a/tmp/$dname-missing"
+    local d="/a/tmp/$dname-diff"
+    [[ -e $d ]] && rm "$d"
+    [[ -e $m ]] && rm "$m"
+    local msize=0
+    local fsfile
+    while read -r line; do
+        fsfile="$1${line#.}"
+        if [[ -e "$fsfile" ]]; then
+            md5diff "$line" "$fsfile" && tee -a "/a/tmp/$dname-diff" <<< "$fsfile $line"
+        else
+            missing=true
+            echo "$line" >> "$m"
+            msize=$((msize + 1))
+        fi
+    done < <(find -type f )
+    if $missing; then
+        echo "$m"
+        (( msize <= 100 )) && cat $m
+    fi
+}
+
+fsdiff-test() {
+    cd $(mktemp -d)
+    echo ok > a
+    echo nok > b
+    mkdir c
+    echo ok > c/d
+    local x=$(mktemp -d)
+    mkdir $x/c
+    echo different > $x/c/d
+    echo ok > $x/a
+    fsdiff $x
+}
+# expected output, with different tmp dirs
+# /tmp/tmp.HDPbwMqdC9/c/d ./c/d
+# /a/tmp/tmp.qLDkYxBYPM-missing
+# ./b
+
+
+# test whether missing files were renamed, generally for use with fsdiff
+# $1 = fsdiff output file, $2 = directory to compare to. pwd = fsdiff dir
+# echos non-renamed files
+rename-test() {
+    local x y found
+    unset sums
+    for x in "$2"/*; do
+        { sums+=( "$(md5sum < "$x")" ) ; } 2>/dev/null
+    done
+    while read -r line; do
+        { missing_sum=$(md5sum < "$line") ; } 2>/dev/null
+        renamed=false
+        for x in "${sums[@]}"; do
+            if [[ $missing_sum == "$x" ]]; then
+                renamed=true
+                break
+            fi
+        done
+        $renamed || echo "$line"
+    done < "$1"
+    return 0
+}
+
+
+# get a random string
+#par2rbase=$(head -c 50 /dev/urandom | tr -cd '[:alpha:]')
+par2r() {
+    [[ $par2rbase ]] || { echo "set \$par2rbase first"; return 1; }
+    d="$PWD"
+    for x in **; do
+        if [[ -d $x ]]; then
+            cd "$x"
+            par2 c QDLDeDJ6z4.par2 *
+            cd "$d"
+        fi
+    done
+
+}
+
+md5diff() {
+    [[ $(md5sum < "$1") != $(md5sum < "$2") ]]
+}
+
+
 pfind() { #find *$1* in $PATH
     [[ $# != 1 ]] && { echo requires 1 argument; return 1; }
     local pathArray
@@ -542,10 +702,8 @@ pfind() { #find *$1* in $PATH
     find "${pathArray[@]}" -iname "*$1*"
 }
 
-
-pwd() { # do pwd + some other info.
-    echo "$(ll -d "$PWD")              $USER@$HOSTNAME         $(date +%r)"
-}
+# do pwd + some other info.
+#pwd() { echo "$(ll -d "$PWD")         $USER@$HOSTNAME         $(date +%r)"; }
 
 
 pwgen() { # generate a random password, with digits & punctuation and without
@@ -553,6 +711,7 @@ pwgen() { # generate a random password, with digits & punctuation and without
     head -c 200 /dev/urandom | tr -cd '[:graph:]' | head -c "$arg"
     echo
     head -c 200 /dev/urandom | tr -cd '[:alnum:]' | head -c "$arg"
+    head -c 5 /dev/urandom | tr -cd '[:alpha:]' | head -c "$arg"
     echo
 }
 
@@ -563,7 +722,30 @@ q() { # start / launch a program in the backround and redir output to null
 
 
 r() {
-    exit "$@"
+    exit "$@" 2>/dev/null
+}
+
+# trash-restore lists everything that has been trashed at or below CWD
+# This picks out files just in CWD, not subdirectories,
+# which also match grep $1, usually use $1 for a time string
+# which you get from running restore-trash once first
+pick-trash() {
+    local name x ask
+    local nth=1
+    # last condition is to not ask again for ones we skipped
+    while name="$( echo | restore-trash | gr "$PWD/[^/]\+$" | gr "$1" )" \
+            && [[ $name ]] && (( $(wc -l <<<"$name") >= nth )); do
+        name="$(echo "$name" | head -n $nth | tail -n 1 )"
+        read -p "$name [Y/n] " ask
+        if [[ ! $ask || $ask == [Yy] ]]; then
+            x=$( echo "$name"  | gr -o "^\s*[0-9]*" )
+            echo $x | restore-trash > /dev/null
+        elif [[ $ask == [Nn] ]]; then
+            nth=$((nth+1))
+        else
+            return
+        fi
+    done
 }
 
 # rsync, root is required to keep permissions right.
@@ -589,7 +771,7 @@ complete -F _root_command s sb
 
 # use -ll, less secure but faster.
 srm () {
-    srm -ll "$@"
+    command srm -ll "$@"
 }
 
 # sudo redo. be aware, this command may not work right on strange distros or earlier software
@@ -601,6 +783,8 @@ sr() {
     fi
 }
 
+rbpipe() { rbt post -o --diff-filename=- "$@"; }
+rbp() { rbt post -o "$@"; }
 
 
 # log with script. timing is $1.t and script is $1.s
@@ -631,13 +815,34 @@ splay() { # script replay
 }
 
 
+# like -e for functions. returns on error.
+# at the end of the function, disable with:
+# trap ERR
+funce() {
+    trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
+${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\"  }\$?=$?"
+trap ERR
+return' ERR
+}
 
 # timer in minutes
 tm() {
-    (sleep $(calc "$@ * 60") && mpv /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
+    (sleep $(calc "$@ * 60") && mpv --volume 50 /a/bin/data/alarm.mp3) > /dev/null 2>&1 &
 }
 
 
+myunison() {
+    s unison -auto -owner -group
+}
+
+tu() {
+    local s;
+    local dir="$(dirname "$1")"
+    if [[ -e $1 && ! -w $1 || ! -w $(dirname "$1") ]]; then
+        s=s;
+    fi
+    $s teeu "$@"
+}
 ts() { # start editing a new file
     [[ $# != 1 ]] && echo "I need a filename." && return 1
     local quiet
@@ -711,23 +916,26 @@ else
 fi
 
 
+
+
 # todo, update this
 complete -F _longopt la lower low rlt rld rl lld ts ll dircp ex fcp fct fpst gr
 
 
 
 hl() { # history limit. Write extra history to archive file.
-    local max_lines linecount tempfile
+    local max_lines linecount tempfile prune_lines x
     local harchive="${HISTFILE}_archive"
     for x in "$HISTFILE" "$harchive"; do
-        if [[ ! $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]]; then
-            echo "error in hl: history file $x no good."
+        [[ -e $x ]] || { touch "$x" && echo "notice from hl(): creating $x"; }
+        if  [[ ! $x || ! -e $x || ! -w $x || $(stat -c "%u" "$x") != $EUID  ]];  then
+            echo "error in hl: history file \$x:$x no good"
            return 1
         fi
     done
-    history -w
+    history -a # save history
     max_lines=$HISTFILELINES
-    [[ $max_lines ]] || { echo "error in hl: failed to get max line count"; return 1; }
+    [[ $max_lines =~ ^[0-9]+$ ]] || { echo "error in hl: failed to get max line count"; return 1; }
     linecount=$(wc -l < $HISTFILE) # pipe so it doesn't output a filename
     [[ $linecount =~ ^[0-9]+$ ]] || { echo "error in hl: wc failed"; return 1; }
     if (($linecount > $max_lines)); then
@@ -737,8 +945,28 @@ hl() { # history limit. Write extra history to archive file.
     fi
 }
 
-# commands to run when bash exits normally
-trap "hl; smh" EXIT
+############## work stuff #############
+
+rn() {
+    pushd /sdx/test/sandbox/;
+    ./setup.sh;
+    ./run.sh;
+    popd
+}
+
+vrm() {
+    virsh destroy $1
+    virsh undefine $1
+}
+
+
+
+
+############# some other section
+if [[ $- == *i* ]]; then
+    # commands to run when bash exits normally
+    trap "hl; _smh" EXIT
+fi
 
 
 # temporary variables to test colorization
@@ -830,18 +1058,15 @@ if [[ $- == *i* ]]; then
     fi
 
     # this needs to come before next ps1 stuff
-    if [[ $BASH_VERSION == [456789]* ]]; then
-        shopt -s autocd
-        shopt -s globstar
-        shopt -s dirspell
-        PS1='\w'
-        if [[ $- == *i* ]]  && [[ ! $INSIDE_EMACS ]]; then
-            PROMPT_DIRTRIM=2
-           bind -m vi-command B:shell-backward-word
-           bind -m vi-command W:shell-forward-word
-        fi
-    else
-        PS1='\W'
+    # this stuff needs bash 4, feb 2009,
+    # old enough to no longer condition on $BASH_VERSION anymore
+    shopt -s autocd
+    shopt -s dirspell
+    PS1='\w'
+    if [[ $- == *i* ]]  && [[ ! $INSIDE_EMACS ]]; then
+        PROMPT_DIRTRIM=2
+       bind -m vi-command B:shell-backward-word
+       bind -m vi-command W:shell-forward-word
     fi
 
     if [[ $SSH_CLIENT ]]; then
@@ -855,7 +1080,7 @@ if [[ $- == *i* ]]; then
         unset IFS
         history -a # save history
         history -n # read any new history
-        if [[ ! DESKTOP_SESSION == xmonad && $TERM == *(screen*|xterm*|rxvt*) ]]; then
+        if [[ ! $DESKTOP_SESSION == xmonad && $TERM == *(screen*|xterm*|rxvt*) ]]; then
             # from the screen man page
             if [[ $TERM == screen* ]]; then
                 local title_escape="\033]..2;"
@@ -870,10 +1095,10 @@ if [[ $- == *i* ]]; then
                ps_char='\$'
                ;;
            1) ps_color="$(get_term_color green)"
-               ps_char=$return
+               ps_char="$return \\$"
                ;;
            *) ps_color="$(get_term_color yellow)"
-               ps_char=$return
+               ps_char="$return \\$"
                ;;
         esac
         if [[ ! -O . ]]; then # not owner
@@ -883,17 +1108,21 @@ if [[ $- == *i* ]]; then
                ps_color="$(get_term_color bold green)"
             fi
         fi
-        PS1="${PS1/%!(*[wW]*)}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
+        PS1="${PS1%"${PS1#*[wW]}"}$(__git_ps1 ' (%s)') \[$ps_color\]$ps_char\[$(get_term_color nocolor)\] "
     }
     PROMPT_COMMAND=prompt_command
 fi
 
 
+
+
+
 ###########################################
 # stuff that makes sense to be at the end #
 ###########################################
 if [[ "$SUDOD" ]]; then
     cd "$SUDOD"
+    unset SUDOD
 elif [[ -d /a ]] && [[ $PWD == $HOME ]] && [[ $- == *i* ]]; then
     cd /a
 fi
@@ -907,3 +1136,25 @@ unset IFS
 if [[ $SOE ]]; then
     errcatch
 fi
+
+# I'd prefer to have system-wide, plus user ruby, due to bug in it
+# https://github.com/rubygems/rubygems/pull/1002
+# further problems: installing multi-user ruby and user ruby,
+# you don't get multi-user ruby when you sudo to root, unless its sudo -i.
+# There a third hybrid form, which passenger error suggested I use,
+# but it didn't actually work.
+
+# in cased I never need this
+# rvm for non-interactive shell: modified from https://rvm.io/rvm/basics
+#if [[ $(type -t rvm) == file && ! $(type -t ruby) ]]; then
+#    source $(rvm 1.9.3 do rvm env --path)
+#fi
+
+# based on warning from rvmsudo
+export rvmsudo_secure_path=1
+
+if [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
+    source "/usr/local/rvm/scripts/rvm"
+fi
+# make our last exit code be 0
+true